#ifndef dmmcgrath_H
#define dmmcgrath_H
#define EMPTY 0  
#define PLAY1 1  
#define PLAY2 -1  
#include "Configuration.h"
#include <stdlib.h>
#include <time.h>
#include <map>
using namespace std;

namespace dmmcgrath{
  
struct Node{
  int score_;         //score of the node
  int key;
  Node* child_[NUMSQUARES][NUMSQUARES];  /*use 2 d array of Node* so that index of array can be
                         used to correspond to where a piece was placed.  for
                         example if the piece is placed at 0,0 then the
                         pointer for that move is to 0,0*/
  Node();
};

/*We use a 2D int array to represent a board, a value of 0 in the board means it is not occupied, a value of 1 means player 1 owns the board, -1 means player 2 owns the board.  We will assume we are creating the game tree for player 1.*/
class GameTree{
  int player_;
  Node* root_;
  Node* CreateTree(int board[][NUMSQUARES],int lvl,int row,int col,int prow,int pcol,int oldkey,int pieces);
  int bestrow_;          //row position of best move at root level
  int bestcol_;          //col position of best move at root level
  int height_;
  int oprow;
  int opcol;
  int R[15][15][3];
  std::map<int, int> transposition;
public:
  /*given the current board, create a full game tree.  The constructor acts 
    as a wrapper that calls the CreateTree function*/
  GameTree(int board[][NUMSQUARES],int player,int height, int oprow_,int opcol_,int lastprow,int lastpcol,int oldkey, int X[15][15][3],int pieces) { //remember to change the height to 4 here or
                                                     //overide the default in p1/p2
    player_=player;                 //either 1 or -1.
    height_=height;
	oprow = oprow_;
    opcol = opcol_;
	memcpy(R,X,((sizeof(int)*15)*15)*3);
	   

    root_=CreateTree(board,0,-1,-1,lastprow,lastpcol,oldkey,pieces);
  }
  void GetBest(int& r,int&c,int&lastprow,int&lastpcol,int& key, int&pieces){
    r=bestrow_;
    c=bestcol_;
	lastprow = bestrow_;
	lastpcol = bestcol_;
	pieces++;
	key = key ^ R[bestrow_][bestcol_][0];
	key ^= R[bestrow_][bestcol_][player_];
  }
  ~GameTree();
  void DestroyTree(Node* root);
  void generateMove(int board[][NUMSQUARES],int oprow,int opcol,int prow, int pcol,int lvl, Node* nn,int whomoves,int oldkey,int pieces);
  	

};
int Eval(int board[][NUMSQUARES],int player,int oprow,int opcol,int prow, int pcol);

}


#endif